tinymce.PluginManager.add('epsilon_wp', function(editor, url) {
    
    
 editor.settings.extended_valid_elements += ",math[*],menclose[*],merror[*],mfenced[*],mfrac[*],mglyph[*],mi[*],mlabeledtr[*],mmultiscripts[*],mn[*],mo[*],mover[*],mpadded[*],mphantom[*],mroot[*],mrow[*],ms[*],mspace[*],msqrt[*],mstyle[*],msub[*],msubsup[*],msup[*],mtable[*],mtd[*],mtext[*],mtr[*],munder[*],munderover[*],semantics[*],maction[*]";
 
 editor.settings.extended_valid_elements +="span[*]";
 editor.settings.extended_valid_elements +="svg[*],path[*],line[*],polyline[*],text[*]";
 
 
    
     // Add a button that opens a window
 editor.addButton('epsilon', {
  text:'New EW',
  image: 'http://www.epsilonwriter.com/images/eWcondense.png',
  tooltip: "Edit with EpsilonWriter",
  onclick: function () {
     //dernierEdit='mytextarea';
     //epsiwriter_execute('lang',language);
    displayModal();
    epsiwriter_execute("lang",language);
    epsiwriter_sendToEpsiWriter("new",""); 
  }
});
 
//content update from TinyMCE to web page
 editor.addButton('format', {
   text:'Format EW',
   image: 'http://www.epsilonwriter.com/images/eWcondense.png',
   tooltip: "Format to EW editable",
   onclick: function () {
	   fromPageToTinyMCE();
   }
 });

//content update from TinyMCE to web page
editor.addButton('update', {
  text:'Update content',
  image: 'http://www.epsilonwriter.com/images/eWcondense.png',
  tooltip: "validate content",
  onclick: function () {
    majFromTinyMCE(editor.getContent());
  }
});


   
   editor.on('dblclick',function(e) {
   var tgt=e.target;
   if(tgt.tagName==="IMG" && tgt.hasAttribute("data-eplw")){
          editor.selection.select(tgt);
          tgt.style.border = "thick solid green";
          epsiwriter_execute("lang",language);
          epsiwriter_sendToEpsiWriter('edit',tgt.outerHTML);
          displayModal();    
      }

  });
   
  editor.on('mouseover',function(e){
      var tgt1=e.target;
      if(tgt1.tagName==="IMG" && tgt1.hasAttribute("data-eplw")){
          tgt1.style.border = "thin solid red";
      }
  })
  
  editor.on('mouseout',function(e){
      var tgt2=e.target;
      if(tgt2.tagName==="IMG" && tgt2.hasAttribute("data-eplw")){
          tgt2.style.border = "thin none red";
      }
  })
  
  editor.on('mouseleave',function(e){
	  try{
		  
		 // if(editor.getContent().indexOf("data-eplw")>0 && editor.getContent().indexOf("data:image")>0){
	    	  majFromTinyMCE(editor.getContent()); 
	      //}
	  }
	  catch(excpt){
		  console.log("On MouseLeave - ERROR save_raw -"+excpt.message);
	  }
  })
  
  
  /*editor.on('BeforeSetContent', function (e) {
	  //<span data-eplw-math="begin"></span>
      if(e.content.indexOf("data-eplw-math=\"begin")>0){
    	 // epsiwriter_execute('lang',language);
    	 try{
    		 epsiwriter_execute('toTinyMCE',editor.getContent());  
    	 }
    	 catch(exc){
    		 console.log("erreur"+exc);    	 }
      }
      
      });*/  
    
  
  
  editor.on('SetContent', function (e) {
	      
	  if(e.content.indexOf("img data-eplw")>0){
    	  majFromTinyMCE(editor.getContent()); 
      }
  });
  
  
  /**
   * Function to be called when updating the content with TinyMCE Content.
   * Define your own process of the content returned with the upDateContent fonction
   * @param {type} content
   * @returns {undefined}
   */
  function majFromTinyMCE(content){
	    //pour l'instant on ne met pas à jour la bd
	    var el = document.createElement('div');
	    el.innerHTML=content;
	    var nodl=el.getElementsByTagName("img")
	    
        var k=0;
	    var imgnoneplw=0;
	    while(nodl.length>imgnoneplw){//replacing img tags
	    
	        var d = document.createElement('span');
	        var nelt=nodl[k];
	        if(nelt.hasAttribute("data-eplw")){
	        var deplw=nelt.getAttribute("data-eplw");
	        /* var indexst=deplw.indexOf("|");
	        deplw=deplw.substring(indexst+1);*/
	        //call to decode eplw to mathml
	        var dmathml=epsiwriter_execute("eplwtomathml",deplw);
	        //deplw=atob(deplw);
	        d.setAttribute("data-eplw",deplw);
	        d.innerHTML = dmathml.trim();
	                //var nmath=d.firstChild;
	        //on cree un span
	        nelt.parentNode.replaceChild(d,nelt);
	        d.outerHTML=d.innerHTML;
	        }
	        else {
                imgnoneplw++;
                k=imgnoneplw;
            }
	    }
	    content=el.innerHTML;
	   updateContent(content);
	} 
  
try{
	if(language==="fr"){
    tinymce.addI18n('fr_FR',{
    	"New EW": "Nouveau",
    	"Edit with EpsilonWriter": "Editer avec EpsilonWriter",
    	});
	}
	else{
    tinymce.addI18n('en_US',{
    	"New EW": "New",
    	"Edit with EpsilonWriter": "Edit with EpsilonWriter",
    	});
	}
}
    
catch (excpt){
	 console.log("ARI-tinymce plugin -locale error: "+language);
	 }

      
});
  
 
  
